<template xmlns="">
  <div class="container">
    <!-- <div class="logo"></div> -->
    <!-- 登录区域 -->
    <div class="content">
      <!-- 配图 -->
      <div class="pic"></div>
      <!-- 表单 -->
      <div class="field">
        <!-- [移动端]标题 -->
        <h2 class="mobile-title">
          <h3 class="title">爱思系统</h3>
        </h2>

        <!-- 表单 -->
        <div class="form-cont">
          <div class="login-title">账号登录</div>
          <el-tabs class="form" v-model="loginForm.loginType" style=" float:none;">
            <el-tab-pane label="密码登录" name="uname">
            </el-tab-pane>
            <el-tab-pane label="验证码登录" name="sms">
            </el-tab-pane>
          </el-tabs>
          <div>
            <el-form ref="loginForm" :model="loginForm" :rules="LoginRules" class="login-form">
             
              <!-- 账号密码登录 -->
              <div v-if="loginForm.loginType === 'uname'">
                <el-form-item prop="username">
                  <el-input v-model="loginForm.username" type="text" auto-complete="off" placeholder="手机号">
                    <svg-icon slot="prefix" icon-class="user" class="el-input__icon input-icon"/>
                  </el-input>
                </el-form-item>
                <el-form-item prop="password">
                  <el-input v-model="loginForm.password" type="password" auto-complete="off" placeholder="密码"
                            @keyup.enter.native="getCode">
                    <svg-icon slot="prefix" icon-class="password" class="el-input__icon input-icon"/>
                  </el-input>
                </el-form-item>
                <el-checkbox v-model="loginForm.rememberMe" style="margin:0 0 25px 0;">记住密码</el-checkbox>
                <a class="forget-password" href="/password/forget">忘记密码?</a>
              </div>

              <!-- 短信验证码登录 -->
              <div v-if="loginForm.loginType === 'sms'">
                <el-form-item prop="mobile">
                  <el-input v-model="loginForm.mobile" type="text" auto-complete="off" placeholder="请输入手机号">
                    <svg-icon slot="prefix" icon-class="phone" class="el-input__icon input-icon"/>
                  </el-input>
                </el-form-item>
                <el-form-item prop="mobileCode">
                  <el-input v-model="loginForm.mobileCode" type="text" auto-complete="off" placeholder="短信验证码"
                            class="sms-login-mobile-code-prefix"
                            @keyup.enter.native="handleLogin">
                    <template>
                      <svg-icon slot="prefix" icon-class="password" class="el-input__icon input-icon"/>
                    </template>
                    <template slot="append">
                      <span v-if="mobileCodeTimer <= 0" class="getMobileCode" @click="getSmsCode" style="cursor: pointer;">获取验证码</span>
                      <span v-if="mobileCodeTimer > 0" class="getMobileCode">{{ mobileCodeTimer }}秒后可重新获取</span>
                    </template>
                  </el-input>
                </el-form-item>
              </div>

              <!-- 下方的登录按钮 -->
              <el-form-item style="width:100%;">
                <el-button :loading="loading" size="medium" type="primary" style="width:100%;"
                    @click.native.prevent="getCode">
                  <span v-if="!loading">登 录</span>
                  <span v-else>登 录 中...</span>
                </el-button>
              </el-form-item>
              <!--  注册 -->
              <div class="register-tip">
                没有账号？
                <span class="register-btn" @click="doRegister()">免费注册</span>
              </div>
            </el-form>
          </div>
        </div>
      </div>
    </div>
    <!-- footer -->
    <!-- <div class="footer">
      Copyright © 2020-2022 iocoder.cn All Rights Reserved.
    </div> -->
  </div>
</template>

<script>
import {sendSmsCode} from "@/api/login";
import {getTenantIdByName} from "@/api/system/tenant";
import {
  getPassword,
  getRememberMe, 
  getUsername,
  removePassword, 
  removeRememberMe, 
  removeUsername,
  setPassword, 
  setRememberMe, 
  setTenantId, 
  setUsername,
  removeTenantId
} from "@/utils/auth";

export default {
  name: "Login",
  data() {
    return {
      mobileCodeTimer: 0,
      loginForm: {
        loginType: "uname",
        username: "",
        password: "",
        mobile: "",
        mobileCode: "",
        rememberMe: false,
      },
      scene: 1,

      LoginRules: {
        username: [
          {required: true, trigger: "blur", message: "手机号不能为空"},
          {
            validator: (rule, value, callback) => {
              // if (/^(?:(?:\+|00)86)?1(?:3[\d]|4[5-79]|5[0-35-9]|6[5-7]|7[0-8]|8[\d]|9[189])\d{8}$/.test(value) === false) {
              //   callback(new Error("手机号格式错误"));
              // } else {
              //   removeTenantId()
              //   getTenantIdByName(value).then(res => {
              //     const tenantId = res.data;
              //     if (tenantId && tenantId >= 0) {
              //       setTenantId(tenantId)
              //       callback();
              //     } else {
              //       callback('该手机号未创建账号,请重新输入');
              //     }
              //   });
              // }
              removeTenantId()
                getTenantIdByName(value).then(res => {
                  const tenantId = res.data;
                  if (tenantId && tenantId >= 0) {
                    setTenantId(tenantId)
                    callback();
                  } else {
                    callback('该手机号未创建账号,请重新输入');
                  }
                });
           
            },
            trigger: 'blur'
          }

        ],
        password: [
          {required: true, trigger: "blur", message: "密码不能为空"}
        ],
        mobile: [
          {required: true, trigger: "blur", message: "手机号不能为空"},
          {
            validator: function (rule, value, callback) {
              if (/^(?:(?:\+|00)86)?1(?:3[\d]|4[5-79]|5[0-35-9]|6[5-7]|7[0-8]|8[\d]|9[189])\d{8}$/.test(value) === false) {
                callback(new Error("手机号格式错误"));
              } else {
                callback();
              }
            }, trigger: "blur"
          }
        ],
      },
      loading: false,
    };
  },
  created() {
    this.getCookie();
  },
  methods: {
    //跳转注册
    doRegister() {
      this.$router.push({path: '/register'})
    },
    getCode() {
      this.handleLogin({})
    },
    getCookie() {
      const username = getUsername();
      const password = getPassword();
      const rememberMe = getRememberMe();
      this.loginForm = {
        ...this.loginForm,
        username: username ? username : this.loginForm.username,
        password: password ? password : this.loginForm.password,
        rememberMe: rememberMe ? getRememberMe() : false,
      };
    },
    handleLogin() {
      this.$refs.loginForm.validate(valid => {
        if (valid) {
          this.loading = true;
           // 设置 Cookie
           if (this.loginForm.rememberMe) {
            setUsername(this.loginForm.username)
            setPassword(this.loginForm.password)
            setRememberMe(this.loginForm.rememberMe)
          } else {
            removeUsername()
            removePassword()
            removeRememberMe()
          }
          // setTenantId(1)
          this.$store.dispatch(this.loginForm.loginType === "sms" ? "SmsLogin" : "Login", this.loginForm).then(() => {
            this.$router.push({path: "/"}).catch(() => {
            });
          }).catch(() => {
            this.loading = false;
          });
        }
      });
    },
    /** ========== 以下为升级短信登录 ========== */
    getSmsCode() {
      if (this.mobileCodeTimer > 0) return;
      this.$refs.loginForm.validate(valid => {
        if (!valid) return;
        sendSmsCode(this.loginForm.mobile, this.scene ).then(res => {
          this.$modal.msgSuccess("获取验证码成功")
          this.mobileCodeTimer = 60;
          let msgTimer = setInterval(() => {
            this.mobileCodeTimer = this.mobileCodeTimer - 1;
            if (this.mobileCodeTimer <= 0) {
              clearInterval(msgTimer);
            }
          }, 1000);
        });
      });
    }
  }
};
</script>
<style lang="scss" scoped>
@import "~@/assets/styles/login.scss";
.forget-password {
  float: right;
    color: #1890ff;
    font-size: 14px;
}
a {
    outline: none;
    text-decoration: none;
}
.login-title{
  color: #141e31;
    font-size: 32px;
    font-weight: 500;
    line-height: 48px;
}
.register-tip{
  color: #141e31;
    font-size: 14px;
    line-height: 20px;
    margin: 10px 0 20px;
}
.register-btn{
  color:  #1890ff;
  cursor: pointer;
}
.oauth-login {
  display: flex;
  align-items: center;
  cursor:pointer;
}
.oauth-login-item {
  display: flex;
  align-items: center;
  margin-right: 10px;
}
.oauth-login-item img {
  height: 25px;
  width: 25px;
}
.oauth-login-item span:hover {
  text-decoration: underline red;
  color: red;
}
.sms-login-mobile-code-prefix {
  :deep(.el-input__prefix) {
    top: 22%;
  }
}
</style>
